package example;

import java.io.IOException;
import java.util.Map;
import java.util.WeakHashMap;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

/**
 *
 *<br>
 *<br>Project: rfx
 *<br>Autor: mark
 *<br>Created: 25.10.2011
 *<br>
 *<br>
 */
public class SynchronizationFilter implements Filter
{

	private Map<String, String> sessionIdMap = new WeakHashMap<String, String>();

	/**
	 * @see javax.servlet.Filter#init(javax.servlet.FilterConfig)
	 */
	public void init(FilterConfig filterConfig) throws ServletException
	{

	}

	/**
	 * @see javax.servlet.Filter#doFilter(javax.servlet.ServletRequest, javax.servlet.ServletResponse, javax.servlet.FilterChain)
	 */
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException,
			ServletException
	{

		HttpServletRequest req = (HttpServletRequest) request;
		String sessionId = req.getSession().getId();
		String sync = sessionId.intern();

		synchronized (sessionId)
		{

			if (!sessionIdMap.containsKey(sessionId))
			{
				sessionIdMap.put(sessionId, sync);
			}
			else
			{
				sync = sessionIdMap.get(sessionId);
			}
		}

		synchronized (sync)
		{
			chain.doFilter(request, response);
		}

	}
	/**
	 * @see javax.servlet.Filter#destroy()
	 */
	public void destroy()
	{

		sessionIdMap.clear();
	}

}
